import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React from 'react';
export default function useExpandToggle() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$initialExpanded = _ref.initialExpanded,
      initialExpanded = _ref$initialExpanded === void 0 ? false : _ref$initialExpanded;

  var _React$useState = React.useState({
    action: '',
    expanded: initialExpanded
  }),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      state = _React$useState2[0],
      setState = _React$useState2[1];

  var unset = React.useCallback(function () {
    setState({
      action: '',
      expanded: false
    });
  }, []);
  var setWith = React.useCallback(function (action) {
    setState({
      action: action,
      expanded: true
    });
  }, []);
  var set = React.useCallback(function () {
    setWith('');
  }, [setWith]);
  var toggleWith = React.useCallback(function () {
    var action = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

    if (state.expanded) {
      unset();
    } else {
      setWith(action);
    }
  }, [setWith, state.expanded, unset]);
  var toggle = React.useCallback(function () {
    toggleWith('');
  }, [toggleWith]);
  return {
    action: state.action,
    set: set,
    setWith: setWith,
    toggle: toggle,
    toggleWith: toggleWith,
    unset: unset,
    value: state.expanded
  };
}
//# sourceMappingURL=useExpandToggle.js.map